"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.default=void 0;require("core-js/modules/es6.symbol");require("core-js/modules/web.dom.iterable");require("core-js/modules/es6.object.set-prototype-of");require("core-js/modules/es7.object.entries");require("core-js/modules/es6.object.assign");require("core-js/modules/es6.function.name");var _react=_interopRequireWildcard(require("react"));var _injectorShape=require("./injectorShape");var _shallowEqual=_interopRequireDefault(require("../../utils/shallowEqual"));var _isPlainObject=_interopRequireDefault(require("../../utils/isPlainObject"));var _invariant=_interopRequireDefault(require("invariant"));var _constants=require("../../constants");var _castToFunction=_interopRequireDefault(require("../../utils/castToFunction"));var _processStyleObject=_interopRequireDefault(require("../../core/processStyleObject"));var _processStyleTree=_interopRequireDefault(require("../../core/processStyleTree"));var _stampObject=_interopRequireWildcard(require("../../core/stampObject"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _interopRequireWildcard(obj){if(obj&&obj.__esModule){return obj;}else{var newObj={};if(obj!=null){for(var key in obj){if(Object.prototype.hasOwnProperty.call(obj,key)){var desc=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):{};if(desc.get||desc.set){Object.defineProperty(newObj,key,desc);}else{newObj[key]=obj[key];}}}}newObj.default=obj;return newObj;}}function _typeof(obj){if(typeof Symbol==="function"&&typeof Symbol.iterator==="symbol"){_typeof=function _typeof(obj){return typeof obj;};}else{_typeof=function _typeof(obj){return obj&&typeof Symbol==="function"&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj;};}return _typeof(obj);}function _extends(){_extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};return _extends.apply(this,arguments);}function _sliceIterator(arr,i){var _arr=[];var _n=true;var _d=false;var _e=undefined;try{for(var _i=arr[Symbol.iterator](),_s;!(_n=(_s=_i.next()).done);_n=true){_arr.push(_s.value);if(i&&_arr.length===i)break;}}catch(err){_d=true;_e=err;}finally{try{if(!_n&&_i["return"]!=null)_i["return"]();}finally{if(_d)throw _e;}}return _arr;}function _slicedToArray(arr,i){if(Array.isArray(arr)){return arr;}else if(Symbol.iterator in Object(arr)){return _sliceIterator(arr,i);}else{throw new TypeError("Invalid attempt to destructure non-iterable instance");}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}function _createClass(Constructor,protoProps,staticProps){if(protoProps)_defineProperties(Constructor.prototype,protoProps);if(staticProps)_defineProperties(Constructor,staticProps);return Constructor;}function _possibleConstructorReturn(self,call){if(call&&(_typeof(call)==="object"||typeof call==="function")){return call;}if(self===void 0){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _inherits(subClass,superClass){if(typeof superClass!=="function"&&superClass!==null){throw new TypeError("Super expression must either be null or a function");}subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});if(superClass)Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass;}function _assertThisInitialized(self){if(self===void 0){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function getDisplayName(Component){return Component.displayName||Component.name||'Component';}var nonProductionEnv=typeof process!=='undefined'&&typeof process.env!=='undefined'&&process.env.NODE_ENV!=='production';var nextVersion=0;function injector(styleTree){var version=nextVersion++;return function wrapWithInject(WrappedComponent){var displayName="inject(".concat(getDisplayName(WrappedComponent),")");var Inject=function(_Component){_inherits(Inject,_Component);function Inject(props,context){var _this;_classCallCheck(this,Inject);_this=_possibleConstructorReturn(this,(Inject.__proto__||Object.getPrototypeOf(Inject)).call(this,props,context));_this.version=version;var configs=context[_constants.CONFIGURATIONS],pipeline=context[_constants.PIPELINE];(0,_invariant.default)(configs,(0,_constants.UNWRAPPED_INJECTOR_ERR)(_this.constructor.displayName));_this.state={styles:(0,_processStyleTree.default)(styleTree,pipeline,configs)};_this.processStyle=_this.processStyle.bind(_assertThisInitialized(_this));_this.computeStyle=_this.computeStyle.bind(_assertThisInitialized(_this));return _this;}_createClass(Inject,[{key:"computeStyle",value:function computeStyle(){var _this2=this;for(var _len=arguments.length,styles=new Array(_len),_key=0;_key<_len;_key++){styles[_key]=arguments[_key];}return(0,_stampObject.default)(styles.reduce(function(acc,style){if(!style||(0,_stampObject.isInlineStylerObject)(style))return Object.assign(acc,style);Object.entries(style).forEach(function(_ref){var _ref2=_slicedToArray(_ref,2),styleKey=_ref2[0],styleValue=_ref2[1];if(styleValue){Object.assign(acc,_this2.state.styles[styleKey]);}});return acc;},{}));}},{key:"processStyle",value:function processStyle(styleObject){if(!styleObject||(0,_stampObject.isInlineStylerObject)(styleObject))return styleObject;var _context=this.context,processingPipeline=_context[_constants.PIPELINE],configs=_context[_constants.CONFIGURATIONS];return(0,_processStyleObject.default)(styleObject,processingPipeline,configs);}},{key:"shouldComponentUpdate",value:function shouldComponentUpdate(nextProps,nextState,nextContext){return!(0,_shallowEqual.default)(this.context[_constants.CONFIGURATIONS],nextContext[_constants.CONFIGURATIONS])||!(0,_shallowEqual.default)(this.props,nextProps);}},{key:"componentWillReceiveProps",value:function componentWillReceiveProps(nextProps,nextContext){var nextConfigs=nextContext[_constants.CONFIGURATIONS];if(!(0,_shallowEqual.default)(this.context[_constants.CONFIGURATIONS],nextConfigs)){var nextPipeline=nextContext[_constants.PIPELINE];this.forceUpdateStyle(nextPipeline,nextConfigs);}}},{key:"forceUpdateStyle",value:function forceUpdateStyle(pipeline,configs){this.setState({styles:(0,_processStyleTree.default)(styleTree,pipeline,configs)});}},{key:"render",value:function render(){return _react.default.createElement(WrappedComponent,_extends({},this.props,{styles:this.state.styles,computeStyle:this.computeStyle,processStyle:this.processStyle}));}}]);return Inject;}(_react.Component);if(nonProductionEnv){Inject.prototype.componentWillUpdate=function componentWillUpdate(){if(this.version===version)return;this.version=version;this.forceUpdateStyle(this.context[_constants.PIPELINE],this.context[_constants.CONFIGURATIONS]);};}Inject.displayName=displayName;Inject.WrappedComponent=WrappedComponent;Inject.contextTypes=_injectorShape.contextTypes;return Inject;};};var _default=injector;exports.default=_default;